? no-lib-2.patch
? no-lib.patch
Index: config/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/config/automake.mk,v
retrieving revision 1.3
diff -u -p -r1.3 automake.mk
--- config/automake.mk	5 Apr 2006 03:21:07 -0000	1.3
+++ config/automake.mk	13 Dec 2006 04:22:28 -0000
@@ -19,20 +19,3 @@ dist_psfonts_DATA = \
 	config/psfonts/Helvetica.afm \
 	config/psfonts/Times-Roman.afm \
 	config/psfonts/Courier.afm
- 
-# A `private installation' in my terms is just having the appropriate
-# configuration files in ~/.pspp instead of a global configuration
-# location.  So I let those files be installed automatically.
-
-private-install:
-	$(mkinstalldirs) $$HOME/.pspp
-	cd $(top_srcdir) && cp $(dist_pkgsysconf_DATA) $$HOME/.pspp
-	$(mkinstalldirs) $$HOME/.pspp/psfonts
-	cd $(top_srcdir) && cp $(dist_psfonts_DATA) $$HOME/.pspp/psfonts
-
-
-private-uninstall:
-	-cd $$HOME/.pspp && rm $(notdir $(dist_pkgsysconf_DATA))
-	-cd $$HOME/.pspp/psfonts && rm $(notdir $(dist_psfonts_DATA))
-	-rmdir $$HOME/.pspp/psfonts $$HOME/.pspp
-
Index: src/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/automake.mk,v
retrieving revision 1.7
diff -u -p -r1.7 automake.mk
--- src/automake.mk	17 Jul 2006 10:45:42 -0000	1.7
+++ src/automake.mk	13 Dec 2006 04:22:28 -0000
@@ -1,7 +1,5 @@
 ## Process this file with automake to produce Makefile.in  -*- makefile -*-
 
-# PSPP
-
 include $(top_srcdir)/src/math/automake.mk
 include $(top_srcdir)/src/libpspp/automake.mk
 include $(top_srcdir)/src/data/automake.mk
@@ -10,4 +8,15 @@ include $(top_srcdir)/src/language/autom
 
 include $(top_srcdir)/src/ui/automake.mk
 
-AM_CPPFLAGS += -I$(top_srcdir)/src -I$(top_srcdir)/lib -DPKGDATADIR=\"$(pkgdatadir)\"
+AM_CPPFLAGS += -I$(top_srcdir)/src -I$(top_srcdir)/lib -I$(top_builddir)/src
+AM_CPPFLAGS += -DPKGDATADIR=\"$(pkgdatadir)\"
+
+if WITHGUI
+AM_CPPFLAGS += $(GTK_CFLAGS) $(GLADE_CFLAGS)
+endif
+
+noinst_LIBRARIES += src/libdata+libpspp.a
+src_libdata_libpspp_a_SOURCES = $(data_sources) $(libpspp_sources)
+
+noinst_LIBRARIES += src/liblanguage+output.a
+src_liblanguage_output_a_SOURCES = $(language_sources) $(output_sources)
Index: src/data/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/automake.mk,v
retrieving revision 1.11
diff -u -p -r1.11 automake.mk
--- src/data/automake.mk	11 Dec 2006 15:39:23 -0000	1.11
+++ src/data/automake.mk	13 Dec 2006 04:22:28 -0000
@@ -1,7 +1,5 @@
 
-noinst_LIBRARIES += src/data/libdata.a
-
-src_data_libdata_a_SOURCES = \
+data_sources = \
 	src/data/any-reader.c \
 	src/data/any-reader.h \
 	src/data/any-writer.c \
Index: src/language/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/automake.mk,v
retrieving revision 1.4
diff -u -p -r1.4 automake.mk
--- src/language/automake.mk	29 Nov 2006 11:50:31 -0000	1.4
+++ src/language/automake.mk	13 Dec 2006 04:22:28 -0000
@@ -10,14 +10,20 @@ include $(top_srcdir)/src/language/stats
 include $(top_srcdir)/src/language/data-io/automake.mk
 include $(top_srcdir)/src/language/expressions/automake.mk
 
-noinst_LIBRARIES += src/language/liblanguage.a 
-
-src_language_liblanguage_a_SOURCES = \
+language_sources = \
 	src/language/syntax-file.c \
 	src/language/syntax-file.h \
 	src/language/prompt.c \
 	src/language/prompt.h \
 	src/language/command.c \
 	src/language/command.h \
-	src/language/command.def 
-
+	src/language/command.def \
+	$(language_lexer_sources) \
+	$(language_xforms_sources) \
+	$(language_control_sources) \
+	$(language_dictionary_sources) \
+	$(language_tests_sources) \
+	$(language_utilities_sources) \
+	$(language_stats_sources) \
+	$(language_data_io_sources) \
+	$(language_expressions_sources)
Index: src/language/control/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/control/automake.mk,v
retrieving revision 1.2
diff -u -p -r1.2 automake.mk
--- src/language/control/automake.mk	15 Mar 2006 03:29:10 -0000	1.2
+++ src/language/control/automake.mk	13 Dec 2006 04:22:28 -0000
@@ -1,9 +1,7 @@
 ## Process this file with automake to produce Makefile.in  -*- makefile -*-
 
 
-noinst_LIBRARIES += src/language/control/libcontrol.a
-
-src_language_control_libcontrol_a_SOURCES = \
+language_control_sources = \
 	src/language/control/control-stack.c \
 	src/language/control/control-stack.h \
 	src/language/control/do-if.c \
Index: src/language/data-io/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/automake.mk,v
retrieving revision 1.7
diff -u -p -r1.7 automake.mk
--- src/language/data-io/automake.mk	18 Jul 2006 04:57:01 -0000	1.7
+++ src/language/data-io/automake.mk	13 Dec 2006 04:22:28 -0000
@@ -1,8 +1,10 @@
 ## Process this file with automake to produce Makefile.in  -*- makefile -*-
 
-noinst_LIBRARIES += src/language/data-io/libdata_io.a
+src_language_data_io_built_sources = \
+	src/language/data-io/file-handle.c \
+	src/language/data-io/list.c
 
-src_language_data_io_libdata_io_a_SOURCES = \
+language_data_io_sources = \
 	src/language/data-io/data-list.c \
 	src/language/data-io/get.c \
 	src/language/data-io/inpt-pgm.c \
@@ -16,18 +18,10 @@ src_language_data_io_libdata_io_a_SOURCE
 	src/language/data-io/data-writer.h \
 	src/language/data-io/file-handle.h \
 	src/language/data-io/placement-parser.c \
-	src/language/data-io/placement-parser.h
-
-src_language_data_io_built_sources = \
-	src/language/data-io/file-handle.c \
-	src/language/data-io/list.c
+	src/language/data-io/placement-parser.h \
+	$(src_language_data_io_built_sources)
 
 all_q_sources += $(src_language_data_io_built_sources:.c=.q)
 EXTRA_DIST += $(src_language_data_io_built_sources:.c=.q)
-
-nodist_src_language_data_io_libdata_io_a_SOURCES = \
-	$(src_language_data_io_built_sources)
-
-
 CLEANFILES += $(src_language_data_io_built_sources)
 
Index: src/language/dictionary/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/automake.mk,v
retrieving revision 1.3
diff -u -p -r1.3 automake.mk
--- src/language/dictionary/automake.mk	6 May 2006 17:46:52 -0000	1.3
+++ src/language/dictionary/automake.mk	13 Dec 2006 04:22:28 -0000
@@ -1,8 +1,6 @@
 ## Process this file with automake to produce Makefile.in  -*- makefile -*-
 
-noinst_LIBRARIES += src/language/dictionary/libcmddict.a
-
-src_language_dictionary_libcmddict_a_SOURCES = \
+language_dictionary_sources = \
  src/language/dictionary/apply-dictionary.c \
  src/language/dictionary/formats.c \
  src/language/dictionary/missing-values.c \
Index: src/language/expressions/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/automake.mk,v
retrieving revision 1.3
diff -u -p -r1.3 automake.mk
--- src/language/expressions/automake.mk	15 Jul 2006 04:38:57 -0000	1.3
+++ src/language/expressions/automake.mk	13 Dec 2006 04:22:28 -0000
@@ -1,12 +1,6 @@
 ## Process this file with automake to produce Makefile.in  -*- makefile -*-
 
-noinst_LIBRARIES += src/language/expressions/libexpressions.a
-
-src_language_expressions_libexpressions_a_CPPFLAGS = $(AM_CPPFLAGS) \
-	-I src/language/expressions \
-	-I $(top_srcdir)/src/language/expressions
-
-src_language_expressions_libexpressions_a_SOURCES = \
+language_expressions_sources = \
 	src/language/expressions/evaluate.c \
 	src/language/expressions/helpers.c \
 	src/language/expressions/helpers.h \
Index: src/language/expressions/evaluate.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/evaluate.c,v
retrieving revision 1.13
diff -u -p -r1.13 evaluate.c
--- src/language/expressions/evaluate.c	10 Dec 2006 03:42:51 -0000	1.13
+++ src/language/expressions/evaluate.c	13 Dec 2006 04:22:28 -0000
@@ -18,14 +18,14 @@
    02110-1301, USA. */
 
 #include <config.h>
-#include "private.h"
+#include "language/expressions/private.h"
 
 #include <ctype.h>
 #include <libpspp/alloc.h>
 #include <libpspp/assertion.h>
 #include <libpspp/message.h>
 #include "helpers.h"
-#include "evaluate.h"
+#include "language/expressions/evaluate.h"
 #include <libpspp/pool.h>
 
 static void
@@ -72,7 +72,7 @@ expr_evaluate (struct expression *e, con
           *(struct substring *) result = ss[-1];
           return;
 
-#include "evaluate.inc"
+#include "language/expressions/evaluate.inc"
           
 	default:
 	  NOT_REACHED ();
Index: src/language/expressions/evaluate.h.pl
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/evaluate.h.pl,v
retrieving revision 1.1
diff -u -p -r1.1 evaluate.h.pl
--- src/language/expressions/evaluate.h.pl	4 Mar 2006 01:11:57 -0000	1.1
+++ src/language/expressions/evaluate.h.pl	13 Dec 2006 04:22:28 -0000
@@ -1,7 +1,7 @@
 do 'generate.pl';
 
 sub generate_output {
-    print "#include \"helpers.h\"\n\n";
+    print "#include \"language/expressions/helpers.h\"\n\n";
 
     for my $opname (@order) {
 	my ($op) = $ops{$opname};
Index: src/language/expressions/optimize.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/optimize.c,v
retrieving revision 1.5
diff -u -p -r1.5 optimize.c
--- src/language/expressions/optimize.c	20 Oct 2006 11:32:57 -0000	1.5
+++ src/language/expressions/optimize.c	13 Dec 2006 04:22:28 -0000
@@ -28,7 +28,7 @@
 #include <data/calendar.h>
 #include <data/data-in.h>
 #include <libpspp/message.h>
-#include "evaluate.h"
+#include "language/expressions/evaluate.h"
 #include "helpers.h"
 #include <libpspp/misc.h>
 #include <libpspp/pool.h>
@@ -155,7 +155,7 @@ evaluate_tree (struct composite_node *no
 {
   switch (node->type) 
     {
-#include "optimize.inc"
+#include "language/expressions/optimize.inc"
 
     default:
       NOT_REACHED ();
Index: src/language/expressions/parse.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/parse.c,v
retrieving revision 1.21
diff -u -p -r1.21 parse.c
--- src/language/expressions/parse.c	11 Dec 2006 15:56:49 -0000	1.21
+++ src/language/expressions/parse.c	13 Dec 2006 04:22:29 -0000
@@ -928,7 +928,7 @@ parse_vector_element (struct lexer *lexe
 /* Individual function parsing. */
 
 const struct operation operations[OP_first + OP_cnt] = {
-#include "parse.inc"
+#include "language/expressions/parse.inc"
 };
     
 static bool
Index: src/language/expressions/private.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/private.h,v
retrieving revision 1.8
diff -u -p -r1.8 private.h
--- src/language/expressions/private.h	11 Dec 2006 15:56:49 -0000	1.8
+++ src/language/expressions/private.h	13 Dec 2006 04:22:30 -0000
@@ -26,7 +26,7 @@
 #include <libpspp/str.h>
 
 #include "public.h"
-#include "operations.h"
+#include "language/expressions/operations.h"
 
 enum operation_flags 
   {
Index: src/language/lexer/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/lexer/automake.mk,v
retrieving revision 1.5
diff -u -p -r1.5 automake.mk
--- src/language/lexer/automake.mk	18 Jul 2006 04:57:01 -0000	1.5
+++ src/language/lexer/automake.mk	13 Dec 2006 04:22:30 -0000
@@ -1,9 +1,7 @@
 ## Process this file with automake to produce Makefile.in  -*- makefile -*-
 
 
-noinst_LIBRARIES += src/language/lexer/liblexer.a
-
-src_language_lexer_liblexer_a_SOURCES = \
+language_lexer_sources = \
 	src/language/lexer/lexer.c  src/language/lexer/lexer.h \
 	src/language/lexer/subcommand-list.c  \
 	src/language/lexer/subcommand-list.h \
Index: src/language/stats/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/automake.mk,v
retrieving revision 1.4
diff -u -p -r1.4 automake.mk
--- src/language/stats/automake.mk	15 Jul 2006 04:38:57 -0000	1.4
+++ src/language/stats/automake.mk	13 Dec 2006 04:22:30 -0000
@@ -1,7 +1,5 @@
 ## Process this file with automake to produce Makefile.in  -*- makefile -*-
 
-noinst_LIBRARIES += src/language/stats/libstats.a
-
 src_language_stats_built_sources = \
 	src/language/stats/correlations.c \
 	src/language/stats/crosstabs.c \
@@ -12,16 +10,7 @@ src_language_stats_built_sources = \
 	src/language/stats/rank.c \
 	src/language/stats/regression.c \
 	src/language/stats/t-test.c
-
-all_q_sources += $(src_language_stats_built_sources:.c=.q)
-EXTRA_DIST += $(src_language_stats_built_sources:.c=.q)
-nodist_src_language_stats_libstats_a_SOURCES = $(src_language_stats_built_sources)
-CLEANFILES += $(src_language_stats_built_sources)
-
-src_language_stats_libstats_a_CPPFLAGS = $(AM_CPPFLAGS) \
-	-I$(top_srcdir)/src/language/stats
-
-src_language_stats_libstats_a_SOURCES = \
+language_stats_sources = \
 	src/language/stats/aggregate.c \
 	src/language/stats/autorecode.c \
 	src/language/stats/descriptives.c \
@@ -29,4 +18,10 @@ src_language_stats_libstats_a_SOURCES = 
 	src/language/stats/sort-criteria.c \
 	src/language/stats/sort-criteria.h \
 	src/language/stats/flip.c \
-	src/language/stats/regression-export.h 
+	src/language/stats/regression-export.h \
+	$(src_language_stats_built_sources)
+
+all_q_sources += $(src_language_stats_built_sources:.c=.q)
+EXTRA_DIST += $(src_language_stats_built_sources:.c=.q)
+CLEANFILES += $(src_language_stats_built_sources)
+
Index: src/language/stats/oneway.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/oneway.q,v
retrieving revision 1.17
diff -u -p -r1.17 oneway.q
--- src/language/stats/oneway.q	10 Dec 2006 03:42:51 -0000	1.17
+++ src/language/stats/oneway.q	13 Dec 2006 04:22:30 -0000
@@ -48,7 +48,7 @@ Foundation, Inc., 51 Franklin Street, Fi
 #include <math/levene.h>
 #include <output/manager.h>
 #include <output/table.h>
-#include "sort-criteria.h"
+#include "language/stats/sort-criteria.h"
 
 #include "gettext.h"
 #define _(msgid) gettext (msgid)
Index: src/language/stats/rank.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/rank.q,v
retrieving revision 1.21
diff -u -p -r1.21 rank.q
--- src/language/stats/rank.q	10 Dec 2006 03:42:51 -0000	1.21
+++ src/language/stats/rank.q	13 Dec 2006 04:22:31 -0000
@@ -21,7 +21,7 @@ Foundation, Inc., 51 Franklin Street, Fi
 
 #include <config.h>
 
-#include "sort-criteria.h"
+#include "language/stats/sort-criteria.h"
 
 #include <data/dictionary.h>
 #include <data/format.h>
Index: src/language/stats/regression.q
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/stats/regression.q,v
retrieving revision 1.41
diff -u -p -r1.41 regression.q
--- src/language/stats/regression.q	10 Dec 2006 03:42:51 -0000	1.41
+++ src/language/stats/regression.q	13 Dec 2006 04:22:31 -0000
@@ -25,7 +25,7 @@
 #include <math.h>
 #include <stdlib.h>
 
-#include "regression-export.h"
+#include "language/stats/regression-export.h"
 #include <data/case.h>
 #include <data/casefile.h>
 #include <data/cat-routines.h>
Index: src/language/tests/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/tests/automake.mk,v
retrieving revision 1.3
diff -u -p -r1.3 automake.mk
--- src/language/tests/automake.mk	28 Oct 2006 04:01:55 -0000	1.3
+++ src/language/tests/automake.mk	13 Dec 2006 04:22:31 -0000
@@ -1,8 +1,6 @@
 ## Process this file with automake to produce Makefile.in  -*- makefile -*-
 
-noinst_LIBRARIES += src/language/tests/libtests.a
-
-src_language_tests_libtests_a_SOURCES = \
+language_tests_sources = \
 	src/language/tests/casefile-test.c \
 	src/language/tests/moments-test.c \
 	src/language/tests/pool-test.c \
Index: src/language/utilities/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/utilities/automake.mk,v
retrieving revision 1.3
diff -u -p -r1.3 automake.mk
--- src/language/utilities/automake.mk	15 Jul 2006 04:38:58 -0000	1.3
+++ src/language/utilities/automake.mk	13 Dec 2006 04:22:31 -0000
@@ -3,19 +3,15 @@
 
 src_language_utilities_built_sources = \
 	src/language/utilities/set.c
+language_utilities_sources = \
+	src/language/utilities/date.c \
+	src/language/utilities/echo.c \
+	src/language/utilities/title.c \
+	src/language/utilities/include.c \
+	src/language/utilities/permissions.c \
+	$(src_language_utilities_built_sources)
 
 all_q_sources += $(src_language_utilities_built_sources:.c=.q)
-
-
 EXTRA_DIST += $(src_language_utilities_built_sources:.c=.q)
-nodist_src_language_utilities_libutilities_a_SOURCES = $(src_language_utilities_built_sources)
 CLEANFILES += $(src_language_utilities_built_sources)
 
-noinst_LIBRARIES += src/language/utilities/libutilities.a
-
-src_language_utilities_libutilities_a_SOURCES = \
-	src/language/utilities/date.c \
-	src/language/utilities/echo.c \
-	src/language/utilities/title.c \
-	src/language/utilities/include.c \
-	src/language/utilities/permissions.c 
Index: src/language/xforms/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/xforms/automake.mk,v
retrieving revision 1.3
diff -u -p -r1.3 automake.mk
--- src/language/xforms/automake.mk	7 Oct 2006 03:10:14 -0000	1.3
+++ src/language/xforms/automake.mk	13 Dec 2006 04:22:31 -0000
@@ -1,9 +1,7 @@
 ## Process this file with automake to produce Makefile.in  -*- makefile -*-
 
 
-noinst_LIBRARIES += src/language/xforms/libxforms.a
-
-src_language_xforms_libxforms_a_SOURCES = \
+language_xforms_sources = \
 	src/language/xforms/compute.c \
 	src/language/xforms/count.c \
 	src/language/xforms/fail.c \
Index: src/libpspp/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/libpspp/automake.mk,v
retrieving revision 1.16
diff -u -p -r1.16 automake.mk
--- src/libpspp/automake.mk	29 Nov 2006 11:50:31 -0000	1.16
+++ src/libpspp/automake.mk	13 Dec 2006 04:22:31 -0000
@@ -1,9 +1,7 @@
 ## Process this file with automake to produce Makefile.in  -*- makefile -*-
 
 
-noinst_LIBRARIES += src/libpspp/libpspp.a
-
-src_libpspp_libpspp_a_SOURCES = \
+libpspp_sources = \
 	src/libpspp/array.c \
 	src/libpspp/array.h \
 	src/libpspp/assertion.h \
@@ -47,18 +45,15 @@ src_libpspp_libpspp_a_SOURCES = \
 	src/libpspp/str.h \
 	src/libpspp/verbose-msg.c \
 	src/libpspp/verbose-msg.h \
+	src/libpspp/version.c \
 	src/libpspp/version.h 
 
 DISTCLEANFILES+=src/libpspp/version.c
 
-src_libpspp_libpspp_a_CPPFLAGS = -I $(top_srcdir)/src/libpspp $(AM_CPPFLAGS)
-
-nodist_src_libpspp_libpspp_a_SOURCES = src/libpspp/version.c
-
 src/libpspp/version.c:
 	@$(top_srcdir)/mkinstalldirs  src/libpspp
 	echo "#include <config.h>" > $@
-	echo "#include \"version.h\"" > $@
+	echo "#include \"libpspp/version.h\"" > $@
 	echo "const char bare_version[] = \"@VERSION@\";" >> $@
 	echo "const char version[] = \"GNU @PACKAGE@ @VERSION@\";" >> $@
 	echo "const char stat_version[] = \"GNU @PACKAGE@ @VERSION@ \
Index: src/math/ts/innovations.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/math/ts/innovations.c,v
retrieving revision 1.16
diff -u -p -r1.16 innovations.c
--- src/math/ts/innovations.c	16 Jul 2006 12:49:13 -0000	1.16
+++ src/math/ts/innovations.c	13 Dec 2006 04:22:32 -0000
@@ -28,6 +28,8 @@
   0-387-97429-6. Sections 5.2, 8.3 and 8.4.
  */
 
+#include <config.h>
+
 #include <gsl/gsl_matrix.h>
 #include <gsl/gsl_vector.h>
 #include <gsl/gsl_math.h>
@@ -37,6 +39,8 @@
 #include <math/coefficient.h>
 #include <math/ts/innovations.h>
 
+#include "xalloc.h"
+
 static void
 get_mean (const gsl_matrix *data,
 	  struct innovations_estimate **est)
Index: src/output/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/output/automake.mk,v
retrieving revision 1.3
diff -u -p -r1.3 automake.mk
--- src/output/automake.mk	3 Apr 2006 20:07:54 -0000	1.3
+++ src/output/automake.mk	13 Dec 2006 04:22:32 -0000
@@ -3,8 +3,6 @@
 
 include $(top_srcdir)/src/output/charts/automake.mk
 
-noinst_LIBRARIES += src/output/liboutput.a 
-
 output_sources = \
 	src/output/afm.c \
 	src/output/afm.h \
@@ -17,16 +15,14 @@ output_sources = \
 	src/output/manager.c \
 	src/output/manager.h \
 	src/output/chart.h \
-	src/output/table.c src/output/table.h
+	src/output/table.c src/output/table.h \
+	$(chart_sources)
 
 
 if WITHCHARTS
-src_output_liboutput_a_SOURCES = $(output_sources) src/output/chart.c
-
+output_sources += src/output/chart.c
 EXTRA_DIST += src/output/dummy-chart.c
 else
-src_output_liboutput_a_SOURCES = $(output_sources) src/output/dummy-chart.c
-
 EXTRA_DIST += src/output/chart.c
 endif
 
Index: src/output/charts/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/output/charts/automake.mk,v
retrieving revision 1.4
diff -u -p -r1.4 automake.mk
--- src/output/charts/automake.mk	15 Mar 2006 03:29:11 -0000	1.4
+++ src/output/charts/automake.mk	13 Dec 2006 04:22:32 -0000
@@ -1,7 +1,7 @@
 ## Process this file with automake to produce Makefile.in  -*- makefile -*-
 
-noinst_LIBRARIES += src/output/charts/libcharts.a
 
+if WITHCHARTS
 chart_sources = \
 	src/output/charts/barchart.c \
 	src/output/charts/barchart.h \
@@ -15,18 +15,10 @@ chart_sources = \
 	src/output/charts/plot-chart.c \
 	src/output/charts/plot-hist.c \
 	src/output/charts/plot-hist.h
-
-if WITHCHARTS
-src_output_charts_libcharts_a_SOURCES = \
-	$(chart_sources)
-
-EXTRA_DIST += src/output/charts/dummy-chart.c
 else
-src_output_charts_libcharts_a_SOURCES =  \
+chart_sources = \
 	src/output/charts/dummy-chart.c
-
-EXTRA_DIST += $(chart_sources)
-
 AM_CPPFLAGS += -DNO_CHARTS
-
 endif
+
+EXTRA_DIST += $(chart_sources)
Index: src/ui/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/ui/automake.mk,v
retrieving revision 1.2
diff -u -p -r1.2 automake.mk
--- src/ui/automake.mk	16 Nov 2006 12:47:22 -0000	1.2
+++ src/ui/automake.mk	13 Dec 2006 04:22:32 -0000
@@ -6,9 +6,7 @@ include $(top_srcdir)/src/ui/gui/automak
 endif
 
 
-noinst_LIBRARIES += src/ui/libuicommon.a
-
-src_ui_libuicommon_a_SOURCES = \
+ui_common_sources = \
 	src/ui/debugger.c \
 	src/ui/debugger.h \
 	src/ui/flexifile.c \
Index: src/ui/gui/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/ui/gui/automake.mk,v
retrieving revision 1.15
diff -u -p -r1.15 automake.mk
--- src/ui/gui/automake.mk	7 Dec 2006 11:10:23 -0000	1.15
+++ src/ui/gui/automake.mk	13 Dec 2006 04:22:32 -0000
@@ -2,20 +2,19 @@
 
 bin_PROGRAMS += src/ui/gui/psppire
 
-src_ui_gui_psppire_CFLAGS = $(GTK_CFLAGS) $(GLADE_CFLAGS) -Wall
-
 src_ui_gui_psppire_LDFLAGS = \
 	-export-dynamic 
 
 src_ui_gui_psppire_LDADD = \
+	src/math/libpspp_math.a			\
+	src/math/linreg/libpspp_linreg.a	\
+	src/math/ts/libpspp_ts.a		\
+	src/libdata+libpspp.a			\
 	$(GTK_LIBS) \
 	$(GLADE_LIBS) \
 	$(top_builddir)/lib/gtksheet/libgtksheet.a \
-	$(top_builddir)/src/ui/libuicommon.a \
-	$(top_builddir)/src/math/libpspp_math.a \
-	$(top_builddir)/src/data/libdata.a \
-	$(top_builddir)/src/libpspp/libpspp.a \
 	$(top_builddir)/gl/libgl.a \
+	lib/linreg/liblinreg.a \
 	@LIBINTL@ @LIBREADLINE@
 
 src_ui_gui_psppiredir = $(pkgdatadir)
@@ -67,4 +66,5 @@ src_ui_gui_psppire_SOURCES = \
 	src/ui/gui/var-sheet.c \
 	src/ui/gui/var-sheet.h \
 	src/ui/gui/var-type-dialog.c \
-	src/ui/gui/var-type-dialog.h
+	src/ui/gui/var-type-dialog.h \
+	$(ui_common_sources)
Index: src/ui/terminal/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/ui/terminal/automake.mk,v
retrieving revision 1.11
diff -u -p -r1.11 automake.mk
--- src/ui/terminal/automake.mk	17 Jul 2006 10:45:43 -0000	1.11
+++ src/ui/terminal/automake.mk	13 Dec 2006 04:22:32 -0000
@@ -1,8 +1,6 @@
 ## Process this file with automake to produce Makefile.in  -*- makefile -*-
 
-noinst_LIBRARIES += src/ui/terminal/libui.a
-
-src_ui_terminal_libui_a_SOURCES = \
+ui_terminal_sources = \
 	src/ui/terminal/command-line.c \
 	src/ui/terminal/command-line.h \
 	src/ui/terminal/read-line.c \
@@ -14,30 +12,18 @@ src_ui_terminal_libui_a_SOURCES = \
 
 bin_PROGRAMS += src/ui/terminal/pspp
 
-src_ui_terminal_pspp_SOURCES =
-
-src_ui_terminal_pspp_LDADD =					\
-	src/ui/terminal/libui.a \
-	src/language/liblanguage.a \
-	src/language/tests/libtests.a \
-	src/ui/libuicommon.a \
-	src/language/utilities/libutilities.a \
-	src/language/control/libcontrol.a \
-	src/language/expressions/libexpressions.a \
-	src/language/stats/libstats.a \
-	src/language/xforms/libxforms.a \
-	src/language/dictionary/libcmddict.a \
-	src/language/lexer/liblexer.a \
-	src/language/data-io/libdata_io.a \
-	src/output/charts/libcharts.a \
-	src/output/liboutput.a \
-	src/math/libpspp_math.a  \
-	src/math/linreg/libpspp_linreg.a  \
-	lib/linreg/liblinreg.a	\
-	lib/gsl-extras/libgsl-extras.a	\
-	src/data/libdata.a \
-	src/libpspp/libpspp.a \
-	gl/libgl.a	\
-	$(LIBICONV) \
+src_ui_terminal_pspp_SOURCES =			\
+	$(ui_common_sources)			\
+	$(ui_terminal_sources)
+
+src_ui_terminal_pspp_LDADD =			\
+	src/liblanguage+output.a		\
+	src/math/libpspp_math.a			\
+	src/math/linreg/libpspp_linreg.a	\
+	src/math/ts/libpspp_ts.a		\
+	src/libdata+libpspp.a			\
+	lib/linreg/liblinreg.a			\
+	lib/gsl-extras/libgsl-extras.a		\
+	gl/libgl.a				\
+	$(LIBICONV)				\
 	@LIBINTL@ @LIBREADLINE@
-