# HG changeset patch
# User John D
# Date 1505797830 14400
#      Tue Sep 19 01:10:30 2017 -0400
# Node ID c7285e784532c601f09dae37dd0fc543151152b8
# Parent  eabf379ccadd31d9e0174a2a5b13635602ec30e6
avoid using version and checksum information from other packages (Bug #52073)

* src/build-yasm.mk, src/gcc-cloog.mk, src/gcc-gmp.mk, src/gcc-isl.mk,
  src/gcc-mpc.mk, src/gcc-mpfr.mk: set version, checksum, subdir, file and url to direct values.

diff -r eabf379ccadd -r c7285e784532 src/build-yasm.mk
--- a/src/build-yasm.mk	Mon Sep 18 19:41:41 2017 -0400
+++ b/src/build-yasm.mk	Tue Sep 19 01:10:30 2017 -0400
@@ -2,12 +2,12 @@
 # See index.html for further information.
 
 PKG             := build-yasm
-$(PKG)_IGNORE    = $(yasm_IGNORE)
-$(PKG)_VERSION  := $(yasm_VERSION)
-$(PKG)_CHECKSUM  = $(yasm_CHECKSUM)
-$(PKG)_SUBDIR    = $(yasm_SUBDIR)
-$(PKG)_FILE      = $(yasm_FILE)
-$(PKG)_URL       = $(yasm_URL)
+$(PKG)_IGNORE   :=
+$(PKG)_VERSION  := 1.3.0
+$(PKG)_CHECKSUM := b7574e9f0826bedef975d64d3825f75fbaeef55e
+$(PKG)_SUBDIR   := yasm-$($(PKG)_VERSION)
+$(PKG)_FILE     := yasm-$($(PKG)_VERSION).tar.gz
+$(PKG)_URL      := http://www.tortall.net/projects/$(PKG)/releases/$($(PKG)_FILE)
 $(PKG)_DEPS     := 
 
 define $(PKG)_UPDATE
diff -r eabf379ccadd -r c7285e784532 src/gcc-cloog.mk
--- a/src/gcc-cloog.mk	Mon Sep 18 19:41:41 2017 -0400
+++ b/src/gcc-cloog.mk	Tue Sep 19 01:10:30 2017 -0400
@@ -2,13 +2,12 @@
 # See index.html for further information.
 
 PKG             := gcc-cloog
-$(PKG)_IGNORE    = $(cloog_IGNORE)
-$(PKG)_VERSION   = $(cloog_VERSION)
-$(PKG)_CHECKSUM  = $(cloog_CHECKSUM)
-$(PKG)_SUBDIR    = $(cloog_SUBDIR)
-$(PKG)_FILE      = $(cloog_FILE)
-$(PKG)_URL       = $(cloog_URL)
-$(PKG)_URL_2     = $(cloog_URL_2)
+$(PKG)_IGNORE   := 
+$(PKG)_VERSION  := 0.18.4
+$(PKG)_CHECKSUM := 8f7568ca1873f8d55bb694c8b9b83f7f4c6c1aa5
+$(PKG)_SUBDIR   := cloog-$($(PKG)_VERSION)
+$(PKG)_FILE     := cloog-$($(PKG)_VERSION).tar.gz
+$(PKG)_URL      := ftp://gcc.gnu.org/pub/gcc/infrastructure/$($(PKG)_FILE)
 $(PKG)_DEPS     := gcc-gmp gcc-isl
 
 define $(PKG)_UPDATE
diff -r eabf379ccadd -r c7285e784532 src/gcc-gmp.mk
--- a/src/gcc-gmp.mk	Mon Sep 18 19:41:41 2017 -0400
+++ b/src/gcc-gmp.mk	Tue Sep 19 01:10:30 2017 -0400
@@ -2,13 +2,13 @@
 # See index.html for further information.
 
 PKG             := gcc-gmp
-$(PKG)_IGNORE    = $(gmp_IGNORE)
-$(PKG)_VERSION  := $(gmp_VERSION)
-$(PKG)_CHECKSUM  = $(gmp_CHECKSUM)
-$(PKG)_SUBDIR    = $(gmp_SUBDIR)
-$(PKG)_FILE      = $(gmp_FILE)
-$(PKG)_URL       = $(gmp_URL)
-$(PKG)_URL_2     = $(gmp_URL_2)
+$(PKG)_IGNORE   :=
+$(PKG)_VERSION  := 6.1.2
+$(PKG)_CHECKSUM := 366ded6a44cd108ba6b3f5b9a252eab3f3a95cdf
+$(PKG)_SUBDIR   := gmp-$($(PKG)_VERSION)
+$(PKG)_FILE     := gmp-$($(PKG)_VERSION).tar.bz2
+$(PKG)_URL      := https://gmplib.org/download/gmp/$($(PKG)_FILE)
+$(PKG)_URL_2    := ftp://ftp.cs.tu-berlin.de/pub/gnu/$(PKG)/$($(PKG)_FILE)
 $(PKG)_DEPS     :=
 
 define $(PKG)_UPDATE
diff -r eabf379ccadd -r c7285e784532 src/gcc-isl.mk
--- a/src/gcc-isl.mk	Mon Sep 18 19:41:41 2017 -0400
+++ b/src/gcc-isl.mk	Tue Sep 19 01:10:30 2017 -0400
@@ -2,13 +2,12 @@
 # See index.html for further information.
 
 PKG             := gcc-isl
-$(PKG)_IGNORE    = $(isl_IGNORE)
-$(PKG)_VERSION   = $(isl_VERSION)
-$(PKG)_CHECKSUM  = $(isl_CHECKSUM)
-$(PKG)_SUBDIR    = $(isl_SUBDIR)
-$(PKG)_FILE      = $(isl_FILE)
-$(PKG)_URL       = $(isl_URL)
-$(PKG)_URL_2     = $(isl_URL_2)
+$(PKG)_IGNORE   :=
+$(PKG)_VERSION  := 0.16.1
+$(PKG)_CHECKSUM := c5a2b201bf05229647e73203c0bf2d9679d4d21f
+$(PKG)_SUBDIR   := isl-$($(PKG)_VERSION)
+$(PKG)_FILE     := isl-$($(PKG)_VERSION).tar.bz2
+$(PKG)_URL      := ftp://gcc.gnu.org/pub/gcc/infrastructure/$($(PKG)_FILE)
 $(PKG)_DEPS     := gcc-gmp
 
 define $(PKG)_UPDATE
diff -r eabf379ccadd -r c7285e784532 src/gcc-mpc.mk
--- a/src/gcc-mpc.mk	Mon Sep 18 19:41:41 2017 -0400
+++ b/src/gcc-mpc.mk	Tue Sep 19 01:10:30 2017 -0400
@@ -2,13 +2,13 @@
 # See index.html for further information.
 
 PKG             := gcc-mpc
-$(PKG)_IGNORE    = $(mpc_IGNORE)
-$(PKG)_VERSION   = $(mpc_VERSION)
-$(PKG)_CHECKSUM  = $(mpc_CHECKSUM)
-$(PKG)_SUBDIR    = $(mpc_SUBDIR)
-$(PKG)_FILE      = $(mpc_FILE)
-$(PKG)_URL       = $(mpc_URL)
-$(PKG)_URL_2     = $(mpc_URL_2)
+$(PKG)_IGNORE   :=
+$(PKG)_VERSION  := 1.0.2
+$(PKG)_CHECKSUM := 5072d82ab50ec36cc8c0e320b5c377adb48abe70
+$(PKG)_SUBDIR   := mpc-$($(PKG)_VERSION)
+$(PKG)_FILE     := mpc-$($(PKG)_VERSION).tar.gz
+$(PKG)_URL      := http://www.multiprecision.org/mpc/download/$($(PKG)_FILE)
+$(PKG)_URL_2    := http://ftp.debian.org/debian/pool/main/m/mpclib/mpclib_$($(PKG)_VERSION).orig.tar.gz
 $(PKG)_DEPS     := gcc-gmp gcc-mpfr
 
 define $(PKG)_UPDATE
diff -r eabf379ccadd -r c7285e784532 src/gcc-mpfr.mk
--- a/src/gcc-mpfr.mk	Mon Sep 18 19:41:41 2017 -0400
+++ b/src/gcc-mpfr.mk	Tue Sep 19 01:10:30 2017 -0400
@@ -2,13 +2,13 @@
 # See index.html for further information.
 
 PKG             := gcc-mpfr
-$(PKG)_IGNORE    = $(mpfr_IGNORE)
-$(PKG)_VERSION   = $(mpfr_VERSION)
-$(PKG)_CHECKSUM  = $(mpfr_CHECKSUM)
-$(PKG)_SUBDIR    = $(mpfr_SUBDIR)
-$(PKG)_FILE      = $(mpfr_FILE)
-$(PKG)_URL       = $(mpfr_URL)
-$(PKG)_URL_2     = $(mpfr_URL_2)
+$(PKG)_IGNORE   :=
+$(PKG)_VERSION  := 3.1.5
+$(PKG)_CHECKSUM := c0fab77c6da4cb710c81cc04092fb9bea11a9403
+$(PKG)_SUBDIR   := mpfr-$($(PKG)_VERSION)
+$(PKG)_FILE     := mpfr-$($(PKG)_VERSION).tar.xz
+$(PKG)_URL      := ftp://ftp.gnu.org/pub/gnu/$(PKG)/$($(PKG)_FILE)
+$(PKG)_URL_2    := http://www.mpfr.org/mpfr-$($(PKG)_VERSION)/$($(PKG)_FILE)
 $(PKG)_DEPS     := gcc-gmp
 
 define $(PKG)_UPDATE